/******************************************************************************
 ** $Id: AuswertungErweitert.java 833 2015-12-27 21:43:54Z wmh $
 ** Diese Datei ist Bestandteil der Java-Quelltexte des Würfelspiels JaFuffy.
 ** Lauffähig ab Java 6.
 ******************************************************************************
 ** Copyright (C) Wolfgang Hauck <wolfgang.hauck@3kelvin.de>
 ******************************************************************************
 ** This program is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** This program is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with this program.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************
 ** Die aktuellste Version von JaFuffy findet sich im Internet unter
 ** <http://jafuffy.3kelvin.de>.
 **
 ** Kommentare, Fehler oder Erweiterungswünsche bitte per E-Mail senden an
 ** <jafuffy@3kelvin.de>.
 ******************************************************************************/
package jafuffy.logik;

import jafuffy.Eigenschaften;

/** Erweiterte Auswertung. */
public class AuswertungErweitert extends AuswertungKlassisch {

    private static final long serialVersionUID = -5463902030609191338L;

    /** Joker-Bonus. */
    public static final int JOKER = 100;
    /** Erwartete Punktzahl pro Spiel (Schätzung). */
    private static final int MITTELWERT = 240;
    /** Standardabweichung (Schätzung). */
    private static final int ABWEICHUNG = 60;

    // Soll "Joker!" bzw. "Bonus"-Meldung erscheinen?
    private boolean joker = false;
    private boolean bonus = false;
    private boolean setzzwang = false;

    /** Regelname. */
    static final String REGEL = "Erweiterte Regeln";

    /**
     * Konstruktor.
     *
     * @param wuerfel
     *            Die im Turnier benutzten Würfel.
     */
    public AuswertungErweitert(Wuerfel[] wuerfel) {
        super(wuerfel);
    }

    /**
     * @return Regelname
     */
    @Override
    public String toString() {
        return REGEL;
    }

    /**
     * Textnachricht "Joker!" setzen?
     *
     * @param setzzwang
     */
    public void setzzwangnachricht(boolean setzzwang) {
        if (setzzwang) {
            // Spieler darf keinen Würfel mehr in den Becher legen
            for (int w = 0; w < 5; w++) {
                wuerfel[w].setEnabled(false);
            }
        }
        this.setzzwang = setzzwang;
    }

    /**
     * Textnachricht "Joker!" setzen?
     *
     * @param joker
     */
    public void jokernachricht(boolean joker) {
        if (joker) {
            // Spieler darf keinen Würfel mehr in den Becher legen
            for (int w = 0; w < 5; w++) {
                wuerfel[w].setEnabled(false);
            }
        }
        this.joker = joker;
    }

    /**
     * Textnachricht "Bonus!" setzen?
     *
     * @param bonus
     */
    public void bonusnachricht(boolean bonus) {
        this.bonus = bonus;
    }

    /**
     * Hat der Spieler einen Joker erwürfelt?
     *
     * @return
     */
    public boolean joker() {
        return super.wert(Tabzeile.JAFUFFY) > 0 && aktiver.punkte(Tabzeile.JAFUFFY) > 0
                && !aktiver.setzbar(Tabzeile.oben(wuerfel[0].augen()));
    }

    /**
     * Setzzwang (JaFuffy gewürfelt, JaFuffy-Feld belegt, oben frei)?
     *
     * @return
     */
    public boolean setzzwang() {
        return super.wert(Tabzeile.JAFUFFY) > 0 && aktiver.punkte(Tabzeile.JAFUFFY) > 0
                && aktiver.setzbar(Tabzeile.oben(wuerfel[0].augen()));
    }

    /**
     * @return geschätzte mittlere Punktzahl pro Spiel
     */
    @Override
    int mittelwert() {
        return MITTELWERT;
    }

    /**
     * @return geschätzte Abweichung von mittlerer Punktzahl pro Spiel
     */
    @Override
    int abweichung() {
        return ABWEICHUNG;
    }

    /**
     * Erwürfelte Punkte für das Eintragsfeld. Berücksichtigt JaFuffy-Bonus.
     *
     * @param eintrag
     *            Nummer des Eintrags auf dem Punktezettel
     * @return Punktzahl
     */
    @Override
    public int wert(Tabzeile eintrag) {
        switch (eintrag) {
        case KLEINESTRASSE:
            return joker() || super.wert(eintrag) > 0 ? Analyse.KleineStrasse.PUNKTE : 0;
        case GROSSESTRASSE:
            return joker() || super.wert(eintrag) > 0 ? Analyse.GrosseStrasse.PUNKTE : 0;
        case JAFUFFY:
            if (super.wert(eintrag) > 0 && aktiver.punkte(eintrag) > 0) {
                return aktiver.punkte(eintrag) + JOKER;
            }
        default:
            return super.wert(eintrag);
        }
    }

    /**
     * @param eintrag
     *            Zeilennummer des Eintrags
     * @return Texteintrag für Tabelle
     */
    @Override
    public String text(Tabzeile eintrag) {
        if (eintrag == Tabzeile.JAFUFFY && joker) {
            return "Joker!";
        } else if (eintrag == Tabzeile.JAFUFFY && bonus) {
            return "Bonus!";
        } else if (setzzwang && eintrag == Tabzeile.oben(wuerfel[0].augen())) {
            return "Gesetzt!";
        } else {
            return null;
        }
    }

    /**
     * @param eintrag
     *            noch nicht gesetzter Eintrag
     * @return Tipp, wieviele Punkte erreichbar inklusive Joker-Meldung
     */
    @Override
    public String spicker(Tabzeile eintrag) {
        if (Eigenschaften.GLOBAL.aktiv("Spicker") && aktiver.gewuerfelt() && joker()
                && eintrag == Tabzeile.JAFUFFY) {
            String text;
            text =
                    "<p align=center><em>Joker (+ 100 Bonuspunkte)!</em></p>"
                            + "<p>Bitte Wurf in freies Feld eintragen.</p>";
            if (tipps()) {
                return "<html>" + text + "<p>Kontextmenü!</p></html>";
            } else {
                return "<html>" + text + "</html>";
            }
        } else {
            return super.spicker(eintrag);
        }
    }

}
